SystemOrganization addCategory: #Chess!

SimpleSwitchMorph subclass: #Casilla
	instanceVariableNames: 'mouseAction pieza'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chess'!

!Casilla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 11:31'!
inicializador: pic
	pieza  := pic .
	self label: pieza img .
	self borderWidth: 2.
	bounds := 0@0 corner: 50@50.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff ! !

!Casilla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/19/2012 06:12'!
inicializador: pic color: c
	pieza  := pic .
	self label: pieza img .
	self label color: c.
	self borderWidth: 2.
	bounds := 0@0 corner: 50@50.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOn! !

!Casilla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 11:29'!
initialize 
	super initialize! !

!Casilla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/6/2012 14:33'!
mouseAction: aBlock
	^mouseAction := aBlock ! !

!Casilla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/6/2012 14:49'!
mouseUp: anEvent
	mouseAction value! !

Object subclass: #GPicture
	instanceVariableNames: 'pic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chess'!

!GPicture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/14/2012 00:16'!
dibujar: p
	| img n i |
	img := pic img.
	n := img size.
	i :=0.
	[ i < n ] whileTrue: [ self parseLine: i cad: ( img at: ( n - 1 - i ) ) ]! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/14/2012 00:29'!
parseChar: c
	| color |
	( c = '_' ) ifTrue: [ color := Color lightGray. ^color ]
	ifFalse: [ ( c='=' ) ifTrue: [ color := Color gray.	^color ] 
			ifFalse: [ ( c='.' ) ifTrue: [ color := Color white. ^color ] 
				ifFalse: [ ( c='@' ) ifTrue: [ color := Color black. ^color ] 
					ifFalse: [ ( c='#' ) ifTrue: [color := Color darkGray. ^color ]
						ifFalse: [ color := Color blue. ^color ] ]]]]! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/14/2012 00:19'!
parseLine: y cad: s
	s size = 0 ifFalse: [
		| xi xf c |
		xi := 0.
		xf := 1.
		c := s at: xi.
		[ xf < s size] whileTrue: [ 
			( c = ' ' & c !!= s at: xf ) ifTrue: [c := s at: xf. xi := xf]
				ifFalse: [ ( c !!= s at: xf ) ifTrue: [ 
						self parseChar: c. 
						"dibujar una linea desde (xi,y) to (xf,y)." 
						c := s at: xf. 
						xi := xf] ].
				xf := xf + 1.
			].
		( c !!= ' ' ) ifTrue: [ self parseChar: c. "dibujar una linea desde (xi,y) to (xf,y)."  ]
	]! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/14/2012 00:06'!
pic: p
	pic := p! !

Object subclass: #Picture
	instanceVariableNames: 'img height width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chess'!

!Picture class methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 23:41'!
alfil
	| pic imag |
	pic := Picture new.
	imag := 'alfil'.
	pic img: imag .
	^pic ! !

!Picture class methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 10:11'!
caballo
	| pic imag |
	pic := Picture new.
	imag := 'caballo'.
	pic img: imag .
	^pic! !

!Picture class methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 10:15'!
casilleroBlanco
	| pic imag |
	pic := Picture new.
	imag := 'blanco'.
	pic img: imag .
	^pic ! !

!Picture class methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 10:11'!
dama
	| pic imag |
	pic := Picture new.
	imag := 'dama'.
	pic img: imag .
	^pic! !

!Picture class methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 10:11'!
peon
	| pic imag |
	pic := Picture new.
	imag := 'torre'.
	pic img: imag .
	^pic! !

!Picture class methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 10:11'!
rey
	| pic imag |
	pic := Picture new.
	imag := 'rey'.
	pic img: imag .
	^pic! !

!Picture class methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 10:11'!
torre
	| pic imag |
	pic := Picture new.
	imag := 'torre'.
	pic img: imag .
	^pic! !

!Picture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 21:51'!
espejoH
	"Devuelve el espejo horizontal de la imagen"
	| pic aux n ns |
	pic := Picture new .
	aux := self img .		
	ns := String new. 
	n := aux size.
	1 to: n do: [ :i | |s| s := aux at: i . ns := ns,(s asString) ]. 
	pic img: ns.
	^pic! !

!Picture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 11:45'!
espejoV
	"Devuelve el espejo vertical de la imagen"
	| pic aux n ns |
	pic := Picture new .
	aux := self img .		
	ns := String new. 
	n := aux size.
	1 to: n do: [ :i | |s| s := aux at: i . ns := (s asString) ,ns ]. 
	pic img: ns.
	^pic! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:10'!
height
	^height! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:11'!
height: alto
	height := alto! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:12'!
img
	^img! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:10'!
img: imagen
	img := imagen
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:16'!
initialize
	super initialize.
	self height:0.
	self width:0
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/19/2012 06:45'!
invColor: col
	|c|
	(col= '_') ifTrue:  [c:= '='] .
	(col= '=') ifTrue:  [c:= '_'].
	(col= '.') ifTrue:  [c:= '@'].
	(col= '@') ifTrue:  [c:= '.'].
	 ^ c ! !

!Picture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/19/2012 06:44'!
negativo: picture
	| pic imag n s ns |
	imag := picture img .
	ns := String new.
	n := imag size .
	1 to: n do: [ :i | s := imag at: i. ns := ns, self invColor: (s asString)].
	pic := Picture new.
	pic img: ns.
	^pic! !

!Picture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 23:36'!
repetirV: n
	| imag acum |
	imag := self img.
	acum := #(imag).
	1 to: n do: [ acum := acum, #(imag) ].	
	^acum! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:10'!
width
	^width! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:12'!
width: ancho
	width := ancho! !

BorderedMorph subclass: #Ajedrez
	instanceVariableNames: 'casillas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chess'!

!Ajedrez methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/6/2012 14:25'!
casillasPorLado 
	"Devuelve el numero de casillas por lado que se va a tener en el tablero"
	^8! !

!Ajedrez methodsFor: 'initialization' stamp: 'AngelaMayhuaQuispe 10/6/2012 14:48'!
initialize
	| cell width height n|
	super initialize.
	n := self casillasPorLado.
	cell := Casilla new.
	width := cell width .
	height := cell height .
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	casillas := Matrix new: n tabulate: [ :i :j | self newCasillaAt: i at: j ].! !

!Ajedrez methodsFor: 'logica juego' stamp: 'AngelaMayhuaQuispe 10/18/2012 10:25'!
modificarCellAt: i at: j
	| celda |
	celda := casillas at: i at: j.
	(i > 0 & j>0) ifTrue: [celda toggleState]! !

!Ajedrez methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/6/2012 14:48'!
newCasillaAt: i at: j
	"Crea una celda en la posicion (i,j) y agrega esto a mi  representacion de pantalla en la posicion apropiada.
	Responde la nueva celda"
	| c origin |
	c := Casilla new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j-1) * c height) + origin.
	c mouseAction: [self modificarCellAt: i at: j].
	^c! !

!Ajedrez methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/18/2012 10:45'!
posicionarPiezas
! !

TestCase subclass: #Test
	instanceVariableNames: 'picture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chess'!

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 16:03'!
setUp
	|body p|
	body := #('#.. ','##= ','###@ ',' ###').
	p := Picture new.
	p img:body! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testAlLado
	|body p|
	body:= #('#.. #.. ', '##= ##= ', '###@###@','  ### ###').
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testEncima
	|body p pn|
	body:= #('#.. ', '##= ', '###@','  ###', '#@@ ', '##_ ', '###. ', ' ###').
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testEspejoH
	|body p|
	body:= #(' ###','###@','##= ','#.. ').
	! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testEspejoV
	|body p|
	body:= #(' ..# ',' =## ','@###',' ### ').
	! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 15:35'!
testInit
	self assert:picture width=4.
	self assert:picture height=4
	! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:09'!
testNegativo
	|body |
	body:= #('#@@ ','##_  ','@###.',' ### ').
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:09'!
testRepetirH
	|body|
	body:= #('#.. #.. #.. ', '##= ##= ##= ', '###@###@###@',' ### ### ###').
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:09'!
testRepetirV
	|body |
	body:= #(' ..# ',' =## ','@###',' ### ',' ..# ',' =## ','@###',' ### ',' ..# ',' =## ','@###',' ### ').
	! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testSuperponer
	|body p |
	body:= #('#..#', '##=#', '###@','####').
! !
